import animation
import blinkenfoo
from animation import Animation
from blinkenroom import Blinkenroom

class darken(Animation):
    def init_animation(self):
        self.frame = self.args["frame"]
        self.rate = float(self.args["rate"])
        self.steps = float(self.args["steps"])
        self.blinkenroom = Blinkenroom(blinkenfoo.DEVICE_LIST_LOUNGE)
        self.name = "darken"
        self._calc_pixel_delta()

    def cycle(self):
        is_dark = True
        for i in range(len(self.frame)):
            delta = self.delta_list[i]
            pixel = self.frame[i]
            value = pixel.value
            if value <= 0:
                continue
            else:
                is_dark = False
            pixel.__setattr__("value", value - delta)
            self.frame[i] = pixel
        self.blinkenroom.send_frame(self.frame)
        if is_dark:
            self.stop()

    def _calc_pixel_delta(self):
        delta_list = []
        self.factor = 100.0 / self.rate
        for i in range(len(self.frame)):
            pixel = self.frame[i]
            value = pixel.value
            new_value = value / self.factor
            delta_per_step = (value - new_value) / self.steps
            delta_list.append(delta_per_step)
        self.delta_list = delta_list
