from blinkenbase.animation import Animation
from blinkenbase.Color import Color

class rainbow(Animation):

    required_args = {
        "fps": [int, 20]
    }

    def init_animation(self):
        self.name = "rainbow"
        self.length = self.blinkenroom.total_length
        step = 360 / self.length
        self.set_fps(self.args["fps"])

        self.gradient = []
        hue = 0
        for i in range(self.length):
            self.gradient.append(Color(hsv=(hue, 1, 1)))
            hue += step
        self.counter = 0

    def cycle(self):
        offset = self.counter % self.length
        self.blinkenroom.send_frame(self.gradient, offset)
        self.counter += 1
