from blinkenbase.animation import Animation
import blinkenbase.blinkenfoo as blinkenfoo
#from blinkenbase.blinkenroom import Blinkenroom
import blinkenbase.blinkenroom as blinkenroom
from blinkenbase.Color import Color
import random

class Blink(object):

    def __init__(self, p_index):
        self.index = p_index
        hue = random.randrange(360)
        self.color = Color(hsv=(hue,1,0))
        self.step_per_cycle = 1.0/ random.randrange(5, 25)
        self.rising = 1
        self.dest_value = 1

    def step(self):
        current_value = self.color.value
        if current_value >= self.dest_value:
            self.rising = -1
        next_value = current_value + self.step_per_cycle * self.rising
        if next_value < 0:
            next_value = 0
        self.color.__setattr__("value", next_value)
        if next_value <= 0:
            return True
        return False

class random_color(Animation):

    required_args = {
        "fps": [int, 20],
        "brightness": [int, 60]
    }

    def init_animation(self):
        self.blinkenroom = blinkenroom.BLINKENROOM_LOUNGE
        self.set_fps(self.args["fps"])
        self.blinkenroom.set_brightness(self.args["brightness"])
        self.blink_dict = {}
        self.name = "random_color"

    def cycle(self):
        for _ in range(3):
            index = random.randrange(self.blinkenroom.total_length)
            if index not in self.blink_dict:
                blink = Blink(index)
                self.blink_dict[index] = blink
        to_pop =[]
        for blink in self.blink_dict.values():
            result = blink.step()
            index = blink.index
            if result:
                to_pop.append(index)
            self.blinkenroom.set_pixel(index, blink.color)
        for index in to_pop:
            self.blink_dict.pop(index, None)
        self.blinkenroom.flush()
