from blinkenbase.animation import Animation
from blinkenbase.Color import Color
from blinkenbase.blinkenroom import Blinkenroom
import blinkenbase.blinkenfoo as blinkenfoo
import time

class sirene(Animation):

    def init_animation(self):
        red = Color((255, 0, 0))
        blue = Color((0, 0, 255))
        #white = Color((255, 255, 255))
        black = Color((0, 0, 0))
        grey = Color((32, 32, 32))
        white = grey
        self.flash_left = [
            [red,   blue,    red,    grey, grey, black, black, black],
            [white, white,  white,  grey, grey, black, black, black],
            [blue,  red,   blue,   grey, grey, black, black, black],
            [white, white,  white,  grey, grey, black, black, black],
            [red,   blue,    red,    grey, grey, black, black, black],
            [white, white,  white,  grey, grey, black, black, black]

        ]
        self.flash_right = [
            [black,   black, black, grey, grey, red,     blue,    red],
            [black,   black, black, grey, grey, white,   white,  white],
            [black,   black, black, grey, grey, blue,    red,   blue],
            [black,   black, black, grey, grey, white,   white,  white],
            [black,   black, black, grey, grey, red,     blue,    red],
            [black,   black, black, grey, grey, white,   white,  white]
        ]
        self.states = [
            self.flash_right,
            self.flash_left
        ]
        self.counter = 0
        self.name = "sirene"
        self.blinkenroom = Blinkenroom([blinkenfoo.CUBES])
        self.set_fps(5)

    def cycle(self):
        i = self.counter % 2
        state = self.states[i]
        for line in state:
            self.blinkenroom.send_frame(line)
            time.sleep(0.06)
        self.counter += 1
